ru.bitel.bgbilling.plugins.documents.server.bean

## Class DocumentStatusDao

- java.lang.Object
- - ru.bitel.common.dao.AbstarctDaoConstant
  - - ru.bitel.common.dao.AbstractDao<DocumentStatus>
    - - ru.bitel.bgbilling.plugins.documents.server.bean.DocumentStatusDao

- All Implemented Interfaces:
    java.lang.AutoCloseable, Directory<DocumentStatus>

      public class DocumentStatusDao
      extends ru.bitel.common.dao.AbstractDao<DocumentStatus>
      implements Directory<DocumentStatus>

  DAO (Data Access Object - объект доступа к данным) для работы со статусами документов. Класс осуществляет вставку/обновление/удаление статусов в БД.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ru.bitel.common.dao.AbstractDao

      `ru.bitel.common.dao.AbstractDao.ResultSetIterator`

  - ### Field Summary

    - ### Fields inherited from class ru.bitel.common.dao.AbstractDao

      `cacheFilter, cacheJoin, cacheOrderBy, cachePaged, cachePS, cacheWhat, con, getByIdPS, mid, moduleId, orderByPattern, tableName`

    - ### Fields inherited from class ru.bitel.common.dao.AbstarctDaoConstant

      `ERROR, SQL_CALC_FOUND_ROWS, SQL_DELETE, SQL_DISTINCT, SQL_EQ, SQL_EQCS, SQL_FROM, SQL_GROUP, SQL_IN, SQL_INSERT, SQL_LIMIT, SQL_ON_DUPLICATE_KEY_UPDATE, SQL_ORDER, SQL_SELECT, SQL_SET, SQL_UPDATE, SQL_VALUES, SQL_WHERE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DocumentStatusDao(java.sql.Connection con)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addStatusLog(DocumentStatusLogItem item)` Добавление записи в таблицу с логами статусов по документу
    `int` | `delete(int id)` Удаление элемента по id
    `DocumentStatus` | `get(int id)` Получение элемента по id
    `DocumentStatus` | `get(java.lang.String title)` Получение элемента по title(name) Может быть не имплементировано - в этом случае бросается `UnsupportedOperationException`
    `protected DocumentStatus` | `getFromRS(java.sql.ResultSet rs)`
    `java.util.List<DocumentStatusLogItem>` | `getStatusHistory(int documentId)` Получение истории изменения статусов документа по коду документа.
    `java.util.List<DocumentStatus>` | `list()` Получение всего списка элементов из справочника
    `protected void` | `updateImpl(DocumentStatus b)` Вставка/Обновление статуса документа в БД.

    - ### Methods inherited from class ru.bitel.common.dao.AbstractDao

      `close, delete, deleteImpl, eq, get, getById, getImpl, getListFromRS, getPeriod, getSQLOrder, getTableName, list, list, listImpl, listImpl, listImplPS, listImplPS, ormFromResultSet, ormUpdateImpl, ormUpdateImpl, processException, recycle, setStatementParam, update`

    - ### Methods inherited from class ru.bitel.common.dao.AbstarctDaoConstant

      `getSQLOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface ru.bitel.bgbilling.kernel.directory.api.common.bean.Directory

      `update`

- - ### Constructor Detail

    - #### DocumentStatusDao

          public DocumentStatusDao(java.sql.Connection con)

  - ### Method Detail

    - #### updateImpl

          protected void updateImpl(DocumentStatus b)
                             throws ru.bitel.bgbilling.common.BGException,
                                    java.sql.SQLException

      Вставка/Обновление статуса документа в БД.
      Specified by:
        `updateImpl` in class `ru.bitel.common.dao.AbstractDao<DocumentStatus>`
      Throws:
        `ru.bitel.bgbilling.common.BGException`
        `java.sql.SQLException`

    - #### get

          public DocumentStatus get(int id)
                             throws ru.bitel.bgbilling.common.BGException

      Description copied from interface: `Directory`
      Получение элемента по id
      Specified by:
        `get` in interface `Directory<DocumentStatus>`
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### list

          public java.util.List<DocumentStatus> list()
                                              throws ru.bitel.bgbilling.common.BGException

      Description copied from interface: `Directory`
      Получение всего списка элементов из справочника
      Specified by:
        `list` in interface `Directory<DocumentStatus>`
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getStatusHistory

          public java.util.List<DocumentStatusLogItem> getStatusHistory(int documentId)
                                                                 throws ru.bitel.bgbilling.common.BGException

      Получение истории изменения статусов документа по коду документа.
      Parameters:
        `documentId` - код документа
      Returns:
        история изменения статусов
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### delete

          public int delete(int id)
                     throws ru.bitel.bgbilling.common.BGException

      Description copied from interface: `Directory`
      Удаление элемента по id
      Specified by:
        `delete` in interface `Directory<DocumentStatus>`
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### addStatusLog

          public void addStatusLog(DocumentStatusLogItem item)
                            throws ru.bitel.bgbilling.common.BGException

      Добавление записи в таблицу с логами статусов по документу
      Parameters:
        `item` - запись лога
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### get

          public DocumentStatus get(java.lang.String title)
                             throws ru.bitel.bgbilling.common.BGException

      Description copied from interface: `Directory`
      Получение элемента по title(name) Может быть не имплементировано - в этом случае бросается `UnsupportedOperationException`
      Specified by:
        `get` in interface `Directory<DocumentStatus>`
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getFromRS

          protected DocumentStatus getFromRS(java.sql.ResultSet rs)
                                      throws java.sql.SQLException,
                                             ru.bitel.bgbilling.common.BGException

      Specified by:
        `getFromRS` in class `ru.bitel.common.dao.AbstractDao<DocumentStatus>`
      Throws:
        `java.sql.SQLException`
        `ru.bitel.bgbilling.common.BGException`